

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

An socket address of some unknown native type.
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Gio.Structs.NativeSocketAddress
    ( 

-- * Exported types
    NativeSocketAddress(..)                 ,
    noNativeSocketAddress                   ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- | Memory-managed wrapper type.
newtype NativeSocketAddress = NativeSocketAddress (ManagedPtr NativeSocketAddress)
-- XXX Wrapping a foreign struct/union with no known destructor or size, leak?
instance WrappedPtr NativeSocketAddress where
    wrappedPtrCalloc = return nullPtr
    wrappedPtrCopy = return
    wrappedPtrFree = Nothing

-- | A convenience alias for `Nothing` :: `Maybe` `NativeSocketAddress`.
noNativeSocketAddress :: Maybe NativeSocketAddress
noNativeSocketAddress = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList NativeSocketAddress
type instance O.AttributeList NativeSocketAddress = NativeSocketAddressAttributeList
type NativeSocketAddressAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
type family ResolveNativeSocketAddressMethod (t :: Symbol) (o :: *) :: * where
    ResolveNativeSocketAddressMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveNativeSocketAddressMethod t NativeSocketAddress, O.MethodInfo info NativeSocketAddress p) => OL.IsLabel t (NativeSocketAddress -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


