

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

Defines a Unix mount entry (e.g. \<filename>\/media\/cdrom\<\/filename>).
This corresponds roughly to a mtab entry.
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Gio.Structs.UnixMountEntry
    ( 

-- * Exported types
    UnixMountEntry(..)                      ,
    noUnixMountEntry                        ,


    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- | Memory-managed wrapper type.
newtype UnixMountEntry = UnixMountEntry (ManagedPtr UnixMountEntry)
foreign import ccall "g_unix_mount_entry_get_type" c_g_unix_mount_entry_get_type :: 
    IO GType

instance BoxedObject UnixMountEntry where
    boxedType _ = c_g_unix_mount_entry_get_type

-- | A convenience alias for `Nothing` :: `Maybe` `UnixMountEntry`.
noUnixMountEntry :: Maybe UnixMountEntry
noUnixMountEntry = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList UnixMountEntry
type instance O.AttributeList UnixMountEntry = UnixMountEntryAttributeList
type UnixMountEntryAttributeList = ('[ ] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
type family ResolveUnixMountEntryMethod (t :: Symbol) (o :: *) :: * where
    ResolveUnixMountEntryMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveUnixMountEntryMethod t UnixMountEntry, O.MethodInfo info UnixMountEntry p) => OL.IsLabel t (UnixMountEntry -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


